var hammertime, mc;
var app = {
	initialize: function () {
		document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
	},
	onDeviceReady: function () {
		this.receivedEvent('deviceready');
		document.addEventListener("backbutton", onBackKeyDown, false);
	},
	receivedEvent: function (id) {
		console.log('Received Event: ' + id);
	}
};

app.initialize();

//<editor-fold defaultstate="collapsed" desc="ONBACKKEYDOWN">
var lastTimeBackPress = 0;
var timePeriodToExit = 2000;
function onBackKeyDown(e) {
	e.preventDefault();
	e.stopPropagation();
	if (secondaryViews.length == 0) {
		console.log('sv length is 0');
		var page = $('.item.active').attr('id');
		if (page == 'page1') {
			if (new Date().getTime() - lastTimeBackPress < timePeriodToExit) {
				navigator.app.exitApp();
			} else {
				window.plugins.toast.showWithOptions({
					message: "Press again to exit.",
					duration: "short", // which is 2000 ms. "long" is 4000. Or specify the nr of ms yourself.
					position: "bottom",
					addPixelsY: -40  // added a negative value to move it up a bit (default 0)
				});
				lastTimeBackPress = new Date().getTime();
			}
		} else {
			$('.carousel').carousel('prev');
		}
	} else {
		var activeView = secondaryViews[secondaryViews.length - 1];
		console.log('activeView is ' + activeView);
		switch (activeView) {
			case 'view_a': //do specific stuff for this view
				break;
//			case 'view_b': //do specific stuff for this view
//			break;
			default:
				exitSecondaryView(activeView);
				break;
		}
	}
}
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="SIDEMENU">
function enterMenu() {
	$('#sidemenu').css({'display': 'block'}).addClass('animated slideInRight');
	$('#overlay').fadeIn();
	setTimeout(function () {
		$('#sidemenu').removeClass('animated slideInRight');
	}, 1000);
}
function exitMenu() {
	$('#sidemenu').addClass('animated slideOutRight');
	$('#overlay').fadeOut();
	setTimeout(function () {
		$('#sidemenu').removeClass('animated slideOutRight').css({'display': 'none'});
	}, 1000);
}
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="SECONDARY VIEWS">
var secondaryViews = [];
var activeView;
function getAnimation(id, direction) {
	return ($('#' + id).hasClass('mg-alert')) ? 'slide' + direction + 'Up' : 'slide' + direction + 'Left';
}
function exitSecondaryView(id) {
	console.log('exitSecondaryView ' + id);
	activeView = id;
//	loader.hide();
//	if (secondaryViews.length > 0 && secondaryViews[secondaryViews.length - 1] != activeView) {
//		return;
//	}
//	var animation = getAnimation(id, 'Out');
	var animation = 'slideOutLeft';
	processSecondaryViewsArrayOnLeave();
	doLeaveAction();
	$('#' + activeView).addClass('animated ' + animation);
	setTimeout(function () {
		$(document).scrollTop(0);
		$('#' + activeView).css('display', 'none').removeClass('animated ' + animation);
	}, 1000);
}
function processSecondaryViewsArrayOnLeave() {
	if (activeView == 'login') {
		secondaryViews = [];
		$('#logging').hide();
	}
	console.log('going to show ' + secondaryViews[secondaryViews.length - 2]);
	if (secondaryViews.length > 1) {
		$('#' + secondaryViews[secondaryViews.length - 2]).show();
	}
	secondaryViews.pop();
}
function doLeaveAction() {
	if (activeView == 'new-customer') {
		loadCustomers();
	} else if (activeView == 'custom-orders') {
		localStorage.removeItem('currentCustomerId');
	} else if (activeView == 'new-order') {
		var customerId = localStorage.getItem('currentCustomerId');
		loadOrders(customerId);
	} else if (activeView == 'new-contact') {
		var customerId = localStorage.getItem('currentCustomerId');
		loadContacts(customerId);
	}
}
function enterSecondaryView(id) {
//	loader.hide();
//	var animation = getAnimation(id, 'In');
	activeView = id;
	var animation = 'slideInLeft';
	console.log('animation for ' + activeView + ' is ' + animation);
	processSecondaryViewsArrayOnEnter();
//	$(document).scrollTop(0);
	doEnterAction();
	$('#' + activeView).css({'display': 'block'}).addClass('animated ' + animation);
	setTimeout(function () {
		$('#' + activeView).removeClass('animated ' + animation);
		if (secondaryViews.length > 1) {
			$('#' + secondaryViews[secondaryViews.length - 2]).hide();
			activeView = '';
		}
	}, 1000);
}
function processSecondaryViewsArrayOnEnter() {
	if ($.inArray(activeView, secondaryViews) == -1) {
		secondaryViews.push(activeView);
	}
}
function doEnterAction() {
	if (activeView == 'customer-orders') {
		var customerId = localStorage.getItem('currentCustomerId');
		loadOrders(customerId);
	} else if (activeView == 'new-order') {
		printNewOrderForm();
	} else if (activeView == 'new-customer') {
		printNewCustomerForm();
	} else if (activeView == 'customer-contacts') {
		var customerId = localStorage.getItem('currentCustomerId');
		loadContacts(customerId);
	} else if (activeView == 'new-contact') {
		printNewContactForm();
	}
}
//</editor-fold>

$(document).ready(function () {
	$('.carousel').carousel('pause', {wrap: true});




//	$(".carousel-inner").swipe({
//		swipeLeft: function () {
//			$(this).parent().carousel('next');
//		},
//		swipeRight: function () {
//			$(this).parent().carousel('prev');
//		},
//		threshold: 200,
//		excludedElements: "label, button, input, select, textarea, .noSwipe"
//	});
//
//	$(".secondary-view").swipe({
//		swipeLeft: function () {
//			var activeView = $(this).attr('id');
//			console.log('swiping sv ' + activeView);
//			exitSecondaryView(activeView);
//		},
//		threshold: 200,
//		excludedElements: "label, button, input, select, textarea, .noSwipe"
//	});

//	occurs before sliding
	$('#myCarousel').on('slide.bs.carousel', function (e) {
		var page = $('.item.active').attr('id');
		if (e.direction == 'left') {
			if (page == 'page4') {
				e.preventDefault();
			}
		} else {
			if (page == 'page1') {
				e.preventDefault();
			}
		}
	});

//	occurs after sliding
	$('#myCarousel').on('slid.bs.carousel', function (e) {
		console.log('stopping hammer');
		$('.view').hammer().stop();
	});
	
//	$('.view').hammer({threshold: 10, velocity: 0.3, direction: Hammer.DIRECTION_LEFT } ).bind('swipeleft', function(e){
	$('.view').hammer({threshold: 10, velocity: 0.3} ).bind('swipeleft', function(e){
//		e.stopPropagation();
		$('.carousel').carousel('next');
	});

//	$('.view').hammer({threshold: 0, velocity: 0.3, direction: Hammer.DIRECTION_RIGHT }).bind('swiperight', function(e){
	$('.view').hammer({threshold: 10, velocity: 0.3}).bind('swiperight', function(e){
//		e.stopPropagation();
		$('.carousel').carousel('prev');
	});
	
	$('.secondary-view').hammer({threshold: 10, velocity: 0.3}).bind('swipeleft', function(e){
		e.stopPropagation();
		var activeView = secondaryViews[secondaryViews.length - 1];
		exitSecondaryView(activeView);
	});

	$(document).on('click', '#cfx-topbar-menu a', function () {
		var target = $(this).data('index');
		console.log("target is " + target);
		$('.carousel').carousel(target);
		switch (target) {
			case 0:
				//do here stuff specific to the view such as loading data...;
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				break;
		}
	});

	$(document).on('click', '#sidemenu-open', function (e) {
		e.preventDefault();
		enterMenu();
	});
	$(document).on('click', '#sidemenu-close', function (e) {
		e.preventDefault();
		exitMenu();
	});

	$(document).on('click', '.view_a', function (e) {
		e.preventDefault();
		exitMenu();
		enterSecondaryView('view_a');
	});

	$(document).on('click', '.view_b', function (e) {
		e.preventDefault();
		exitMenu();
		enterSecondaryView('view_b');
	});

	$(document).on('click', '.view_c', function (e) {
		e.preventDefault();
		exitMenu();
		enterSecondaryView('view_c');
	});

	$(document).on('click', '.back', function (e) {
		e.preventDefault();
		var page = $(this).parents('.secondary-view').attr('id');
		exitSecondaryView(page);
	});
	
});


